SystemOrganization addCategory: #SandstoneDb!
SystemOrganization addCategory: #'SandstoneDb-Tests'!

!String methodsFor: '*sandstonedb-serialization' stamp: 'rjl 7/8/2008 19:44'!
deservesSandstoneReferenceMark
	^ false! !

!String methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:36'!
sandstoneDeepCopy
	^ self shallowCopy! !

!String methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:36'!
sandstoneDeepCopyVisits: visitedParts
	^ self shallowCopy! !

!Character methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:34'!
sandstoneDeepCopy
	^ self! !

!Character methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:34'!
sandstoneDeepCopyVisits: visitedParts
	^ self! !

!Boolean methodsFor: '*sandstonedb' stamp: 'rjl 7/31/2008 17:09'!
deservesSandstoneReferenceMark
	^ false! !

!Boolean methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:32'!
sandstoneDeepCopy
	^ self! !

!Boolean methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:33'!
sandstoneDeepCopyVisits: visitedParts
	^ self! !

!Float methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:35'!
sandstoneDeepCopy
	^ self! !

!Float methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:34'!
sandstoneDeepCopyVisits: visitedParts
	^ self! !

!ArrayedCollection methodsFor: '*sandstonedb' stamp: 'rjl 7/31/2008 17:08'!
deservesSandstoneReferenceMark
	^ false! !

!DataStream class methodsFor: '*sandstonedb' stamp: 'rjl 1/14/2008 08:56'!
fileNamed: aName do: aBlock 
	| file |
	file := self fileNamed: aName.
	^ file 
		ifNil: [ nil ]
		ifNotNil: [ [ aBlock value: file ] ensure: [ file close ] ]! !

!DataStream class methodsFor: '*sandstonedb' stamp: 'rjl 1/14/2008 08:57'!
newFileNamed: aName do: aBlock 
	| file |
	file := self newFileNamed: aName.
	^ file 
		ifNil: [ nil ]
		ifNotNil: [ [ aBlock value: file ] ensure: [ file close ] ]! !

!DataStream class methodsFor: '*sandstonedb' stamp: 'rjl 1/14/2008 08:57'!
oldFileNamed: aName do: aBlock 
	| file |
	file := self oldFileNamed: aName.
	^ file 
		ifNil: [ nil ]
		ifNotNil: [ [ aBlock value: file ] ensure: [ file close ] ]! !

!DataStream class methodsFor: '*sandstonedb' stamp: 'rjl 1/12/2008 16:51'!
readOnlyFileNamed: aString
	| strm |
	strm := self on: (FileStream readOnlyFileNamed: aString).
	strm byteStream setFileTypeToObject.
	^ strm! !

!DataStream class methodsFor: '*sandstonedb' stamp: 'rjl 1/14/2008 08:56'!
readOnlyFileNamed: aName do: aBlock 
	| file |
	file := self readOnlyFileNamed: aName.
	^ file 
		ifNil: [ nil ]
		ifNotNil: [ [ aBlock value: file ] ensure: [ file close ] ]! !

TestCase subclass: #SDActiveRecordTests
	instanceVariableNames: 'mom kid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Tests'!

!SDActiveRecordTests commentStamp: 'rjl 12/19/2007 20:41' prior: 0!
Part of the reason I did this project was to force myself to learn to do more unit testing.  I'm starting to learn to like it.!

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/10/2008 00:17'!
flushAndReload
	SDPersonMock
		coolDown ;
		warmUp! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/9/2008 20:33'!
setUp
	SDPersonMock warmUp.
	SDPersonMock allSubclassesDo: [ :each | each warmUp ].
	mom := SDPersonMock testPerson.
	kid := SDPersonMock testPerson! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 09:26'!
tearDown
	SDPersonMock do: [ :each | each delete ].
	SDPersonMock coolDown.
	SDPersonMock allSubclassesDo: [ :each | each coolDown ]! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/21/2008 16:04'!
testAbort
	kid name: 'Joe'.
	kid save.
	kid name: 'Mary'.
	self assert: kid name = 'Mary'.
	kid abortChanges.
	self assert: kid name = 'Joe'! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 3/10/2008 20:56'!
testArraySerialization
	kid save.
	mom children: {  kid  }.
	mom save.
	self flushAndReload .
	self 
		assert: mom refreshed children
		includes: kid refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/30/2008 09:28'!
testAtIdSubclasses
	| man woman |
	man := SDManMock testPerson save.
	woman := SDWomanMock testPerson save.
	mom save.
	self 
		assert: 3
		equals: SDPersonMock findAll size.
	self assert: (SDPersonMock atId: man id) = man.
	self assert: (SDPersonMock atId: woman id) = woman.
	self 
		assert: 1
		equals: SDManMock findAll size.
	self 
		assert: 1
		equals: SDWomanMock findAll size.
	man delete.
	woman delete! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/1/2008 12:01'!
testBigSave
	| commitTime people |
	people := (1 to: 30) collect: [:it | SDPersonMock testPerson].
	commitTime := [people do: [:each | each save]] timeToRun milliSeconds.
	people do: [:each | each delete].
	Transcript show: commitTime.
	self assert: commitTime < 3 seconds! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 3/10/2008 20:56'!
testCollectionSerialization
	kid save.
	mom children: (OrderedCollection with: kid).
	mom save.
	self flushAndReload .
	self 
		assert: mom refreshed children
		includes: kid refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 12/19/2007 21:04'!
testCreatedOn
	kid save.
	self assert: kid createdOn <= TimeStamp now! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 23:24'!
testDeepCopy
	"sandstoneDeepCopy works just like deepCopy until it hits another active record
	at which point the copying stops, and the actual references is returned."
	| copy obj |
	kid save.
	mom save.
	kid buddy: #not -> (#deeper -> mom).
	obj := Object new.
	kid father: obj.
	copy := kid sandstoneDeepCopy.
	self assert: copy buddy value value == mom.
	self deny: copy father == obj! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 12/30/2007 23:56'!
testDelete
	kid save.
	self deny: kid isNew.
	self assert: kid version equals: 1.
	kid delete.
	self assert: kid isNew.
	self assert: kid version equals: 0! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 2/4/2008 10:46'!
testDeleteAndFind
	kid name: 'zorgle'.
	kid save.
	self deny: kid isNew.
	kid delete.
	self assert: (SDPersonMock find: [:e | e name = 'zorgle']) isNil.
! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 09:31'!
testDeleteOldVersions
	| id |
	kid save.
	kid save.
	id := kid id.
	kid delete.
	self assert: ((SDPersonMock storageDirFor: id) fileNamesMatching: id , '.*') isEmpty! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 3/10/2008 20:56'!
testDictionarySerialization
	kid save.
	mom children: (Dictionary new
			at: #son
				put: kid ;
			yourself).
	mom save.
	self flushAndReload.
	self 
		assert: (mom refreshed children at: #son)
		equals: kid refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 3/10/2008 20:54'!
testEquality
	mom save.
	kid mother: mom.
	kid save.
	self flushAndReload .
	self assert: kid refreshed mother equals: mom refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 3/10/2008 20:22'!
testFind
	kid save.
	self flushAndReload.
	self deny: (SDPersonMock find: [:each | each id = kid id]) isNil.
	self assert: (SDPersonMock find: [:each | each id = 'not']) isNil! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/22/2008 10:45'!
testFindById
	kid save.
	self deny: (SDPersonMock atId: kid id) isNil! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/22/2008 10:45'!
testFindIdentity
	mom save.
	self flushAndReload.
	self assert: (SDPersonMock atId: mom id) == (SDPersonMock atId: mom id)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/1/2008 12:11'!
testFindSubclasses
	| man woman |
	man := SDManMock testPerson save.
	woman := SDWomanMock testPerson save.
	mom save.
	self assert: 3 equals: SDPersonMock findAll size.
	self assert: (SDPersonMock findAll 
				contains: [:e | e class = SDManMock]).
	self assert: 1 equals: SDManMock findAll size.
	self assert: 1 equals: SDWomanMock findAll size .
	man delete.
	woman delete! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 3/10/2008 20:54'!
testIdentity
	mom save.
	kid mother: mom.
	kid save.
	self flushAndReload.
	self assert: kid refreshed mother == mom refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 3/10/2008 20:55'!
testIsNew
	self assert: kid isNew.
	kid save.
	self deny: kid isNew.
	kid delete.
	self assert: kid isNew.! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 1/7/2008 17:57'!
testLoadMissingFile
	kid save.
	(kid class storageDirFor: kid id) assureExistence deleteFileNamed: kid id, '.obj'.
	self 
		should: [ kid class loadObjectFrom: kid id ]
		raise: SDLoadError! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 22:47'!
testMarkReferences
	kid mother: mom.
	mom save.
	kid sandstoneMarkReferences.
	self assert: (kid mother isKindOf: SDRecordMarker)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 22:49'!
testMarkReferencesCopies
	kid save.
	mom children: { kid }.
	mom save.
	self assert: mom children first == kid! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 22:47'!
testMarkReferencesRecursive
	kid buddy: #not -> mom.
	mom save.
	kid sandstoneMarkReferences.
	self assert: (kid buddy value isKindOf: SDRecordMarker)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 22:48'!
testMarkReferencesRecursiveDeeper
	kid buddy: #not -> (#deeper -> mom).
	mom save.
	kid sandstoneMarkReferences.
	self assert: (kid buddy value value isKindOf: SDRecordMarker)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 22:48'!
testMarkReferencesRecursiveDeeperInCollection
	kid buddy: #not -> {  (#deeper -> mom)  }.
	mom save.
	kid sandstoneMarkReferences.
	self assert: (kid buddy value first value isKindOf: SDRecordMarker)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 22:47'!
testMarkReferencesRecursiveDeeperInDictionary
	kid buddy: #not -> { 
				(Dictionary new
					at: #deeper
						put: mom;
					yourself)
			 }.
	mom save.
	kid sandstoneMarkReferences.
	self assert: ((kid buddy value first at: #deeper) isKindOf: SDRecordMarker)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/12/2008 22:48'!
testMarkReferencesRecursiveDeeperNestedList
	kid buddy: #not -> (Array with: (Array with: mom)).
	mom save.
	kid sandstoneMarkReferences.
	self assert: (kid buddy value first first isKindOf: SDRecordMarker)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 7/10/2008 09:42'!
testMarkReferencesRecursiveDeeperNotTouchedInOrig
	| otherKid |
	kid buddy: #not -> (#deeper -> mom).
	otherKid := kid sandstoneDeepCopy.
	otherKid buddy value value save.
	otherKid sandstoneMarkReferences.
	self assert: (kid buddy value value isKindOf: mom class)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 5/13/2008 23:58'!
testMarkReferencesStops
	| other |
	other := SDManMock testPerson save.
	mom father: other.
	kid buddy: #some -> (#time -> mom).
	mom save.
	kid sandstoneMarkReferences.
	self assert: (mom father == other)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 3/19/2008 00:01'!
testPeerIdentity
	mom save.
	kid mother: mom.
	kid save.
	self flushAndReload .
	self assert: kid refreshed mother == mom refreshed.! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/10/2008 21:07'!
testResolveReferences
	mom save.
	kid mother: mom asReferenceMarker.
	kid sandstoneResolveReferences.
	self assert: (kid mother isKindOf: SDActiveRecord)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/10/2008 21:07'!
testResolveReferencesRecursive
	mom save.
	kid buddy: #not -> mom asReferenceMarker.
	kid sandstoneResolveReferences.
	self assert: (kid buddy value isKindOf: SDActiveRecord)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/10/2008 21:07'!
testResolveReferencesRecursiveDeeperNestedList
	mom save.
	kid buddy: #not -> (Array with: (Array with: mom asReferenceMarker)).
	kid sandstoneResolveReferences.
	self assert: (kid buddy value first first isKindOf: SDActiveRecord)! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 12/30/2007 19:08'!
testSaveMissingFile
	self assert: kid isNew.
	kid save.
	self deny: kid isNew.
	(kid class storageDirFor: kid id) assureExistence deleteFileNamed: kid id.
	kid save.
	self deny: kid isNew.! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 3/10/2008 20:57'!
testSetSerialization
	kid save.
	mom children: (Set with: kid).
	mom save.
	self flushAndReload.
	self 
		assert: mom refreshed children
		includes: kid refreshed! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 4/10/2008 20:05'!
testStorageDir
	"Active records id's must find a proper subdirectory entry in the defined structure"
	| ids legalNames |
	legalNames := (0 to: 9) collect: [ : e | e asString ].
	ids := Set new.
	1000 timesRepeat: [ ids add: UUID new asString36 ].
	ids add: 'abaoblwgnaydxokccorveamoq'.
	ids do: [ : anId | self assert: (legalNames includes: (SDPersonMock storageDirFor: anId) localName) ]! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 12/19/2007 21:07'!
testUpdatedOn
	kid save.
	self assert: kid updatedOn <= TimeStamp now! !

!SDActiveRecordTests methodsFor: 'running' stamp: 'rjl 7/14/2008 23:26'!
testVersion
	self assert: kid version equals: 0.
	kid save.
	self assert: kid version equals: 1.
	kid save.
	self assert: kid version equals: 2! !

!Object methodsFor: '*sandstonedb-testing' stamp: 'rjl 7/31/2008 17:08'!
deservesSandstoneReferenceMark
	^ true ! !

!Object methodsFor: '*sandstonedb-testing' stamp: 'sas 4/9/2008 13:20'!
isSandstoneActiveRecord
	"Answers true if the receiver is
	a Sandstone Active Record."

	^ false! !

!Object methodsFor: '*sandstonedb-testing' stamp: 'rjl 7/8/2008 15:40'!
isSandstoneMarker
	^ false! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 7/8/2008 18:07'!
sandstoneDeepCopy
	"Replaces the receiver (sub) active records 
	with Sandstone references where it is needed"
	^ self sandstoneDeepCopyVisits: (IdentityDictionary new: self sandstoneInitialHashSize)! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/18/2008 01:51'!
sandstoneDeepCopyVisits: visitedParts 
	"sandstoneDeepCopy works just like deepCopy until it hits another active record
	at which point the copying stops, and the actual references is returned."
	| newObject class index value |
	visitedParts at: self ifPresent: [ :it | ^ it ].
	class := self class.
	class isVariable 
		ifTrue: 
			[ index := self basicSize.
			newObject := class basicNew: index.
			[ index > 0 ] whileTrue: 
				[ newObject 
					basicAt: index
					put: ((self basicAt: index) sandstoneDeepCopyVisits: visitedParts).
				index := index - 1 ] ]
		ifFalse: [ newObject := class basicNew ].
	visitedParts at: self put: newObject.
	index := class instSize.
	[ index > 0 ] whileTrue: 
		[ value := self instVarAt: index.
		newObject 
			instVarAt: index
			put: (value isSandstoneActiveRecord 
					ifTrue: [ value  ]
					ifFalse: [ value sandstoneDeepCopyVisits: visitedParts ]).
		index := index - 1 ].
	^ newObject! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 7/8/2008 18:06'!
sandstoneInitialHashSize
	^ 10000! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 7/8/2008 18:06'!
sandstoneMarkReferences
	"Replaces the receiver (sub) active records 
	with Sandstone references where it is needed"
	^ self sandstoneMarkReferencesVisits: (IdentityDictionary new: self sandstoneInitialHashSize)! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 7/8/2008 15:40'!
sandstoneMarkReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone active records to become references.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	self deservesSandstoneReferenceMark ifFalse: [ ^ self ].
	visitedParts at: self ifPresent: [:it | ^ it ].
	visitedParts at: self put: self.
	self class allInstVarNames do: 
		[ :name | 
		| var |
		var := self instVarNamed: name.
		var isSandstoneActiveRecord 
			ifTrue: 
				[ self 
					instVarNamed: name
					put: var asReferenceMarker ]
			ifFalse: [ var sandstoneMarkReferencesVisits: visitedParts ] ].
	^ self! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 7/8/2008 18:06'!
sandstoneResolveReferences
	"Replaces the receiver markers with
	active records where it is needed"
	^ self sandstoneResolveReferencesVisits: (IdentityDictionary new: self sandstoneInitialHashSize)! !

!Object methodsFor: '*sandstonedb-serialization' stamp: 'rjl 7/8/2008 16:25'!
sandstoneResolveReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone references to active record to become active records.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	self deservesSandstoneReferenceMark ifFalse: [ ^ self ].
	visitedParts at: self ifPresent: [:it | ^ it ].
	visitedParts at: self put: self.
	self class allInstVarNames do: 
		[ :name | 
		| var |
		var := self instVarNamed: name.
		(var isSandstoneMarker) 
			ifTrue: 
				[ self 
					instVarNamed: name
					put: var asOriginalObject ]
			ifFalse: [ var sandstoneResolveReferencesVisits: visitedParts ] ].
	^ self! !

Object subclass: #SDActiveRecord
	instanceVariableNames: 'id createdOn updatedOn version isNew'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb'!

SDActiveRecord class
	instanceVariableNames: 'locks cache'!

!SDActiveRecord commentStamp: 'rjl 7/31/2008 17:12' prior: 0!
I'm the core of a simple object database based upon a mix of several patterns intended for use with *small* Seaside based web applications.  I am not meant to scale to millions of records, just tens of thousands, but for prototyping and small office applications where the number of records are in the thousands and the number of concurrent users can be handled by a single Squeak image.  To use me, simply subclass me and save your image that's it.  

For more information see http://onsmalltalk.com/programming/smalltalk/sandstonedb-simple-activerecord-style-persistence-in-squeak/
!

SDActiveRecord class
	instanceVariableNames: 'locks cache'!

!SDActiveRecord class methodsFor: 'config' stamp: 'rjl 4/26/2008 22:03'!
initialize
	"ActiveRecord will act as the single agent to ensure all subclasses are 
	correctly initialized on start up.  Previously I had each class managing
	itself but I got tired of forgetting to call #install on a new class before
	I could use it. Now no installation of new classes is required."
	"self initialize"
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.
	self allSubclassesDo: 
		[ :e | 
		Smalltalk removeFromStartUpList: e.
		Smalltalk removeFromShutDownList: e ]! !

!SDActiveRecord class methodsFor: 'private' stamp: 'rjl 5/9/2008 20:41'!
allCaches
	^ self allSubclasses 
		inject: cache
		into: [ :sum :subclass | sum , subclass cache ]! !

!SDActiveRecord class methodsFor: 'private' stamp: 'rjl 4/22/2008 10:52'!
allCurrentVersionNames
	"Recursively searching for files allows the directory paths to be 	hashed 
	to split the files up into many directories to break the max file per 
	directoy limit and keep things fast, and makes queries return all instances 
	of this class and it's subclasses, a nice simple way to deal with inheritance"
	^ self storageDirectory fileNamesRecursively select: [ :each | each endsWith: '.obj' ]! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 4/22/2008 10:46'!
atId: anId 
	^ self 
		atId: anId
		ifAbsent: [ nil ]! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 4/30/2008 09:29'!
atId: anId ifAbsent: aHandler 
	^ self allCaches
		at: anId
		ifAbsent: aHandler! !

!SDActiveRecord class methodsFor: 'private' stamp: 'rjl 5/9/2008 20:18'!
cache
	^ cache! !

!SDActiveRecord class methodsFor: 'private' stamp: 'rjl 5/9/2008 21:09'!
cachedLoadFrom: anId 
	^ cache 
		at: anId
		ifAbsent: 
			[ ([ self loadObjectFrom: anId ] 
				on: SDLoadError
				do: [ nil ]) ifNotNilDo: 
				[ :it | 
				"seems I have to make sure to cache the object before I can resolve 
				it's references so any backreferences to it don't try and load from disk again''"
				cache at: anId put: it.
				it sandstoneResolveReferences ] ]! !

!SDActiveRecord class methodsFor: 'actions' stamp: 'rjl 5/9/2008 22:53'!
coolDown
	self ensureReady ! !

!SDActiveRecord class methodsFor: 'accessing' stamp: 'rjl 4/1/2008 12:14'!
defaultBaseDirectory
	"you can override this if you want to force the db somewhere else"
	^ FileDirectory default! !

!SDActiveRecord class methodsFor: 'private' stamp: 'rjl 7/8/2008 09:14'!
defaultCacheSize
	^ 10000! !

!SDActiveRecord class methodsFor: 'crash recovery' stamp: 'rjl 7/31/2008 16:57'!
deleteFailedCommits
	"all remaining .new files are failed commits, kill them"
	
	[ self storageDirectory fileNamesRecursively 
		select: [ :each | each endsWith: '.new' ]
		thenDo: [ :each | (self storageDirFor: each) deleteFileNamed: each ] ] 
		on: Error
		do: [ :err | Transcript show: err ]! !

!SDActiveRecord class methodsFor: 'private' stamp: 'rjl 7/31/2008 17:06'!
dirNameFor: anId 
	"Answers a string with one decimal digit corresponding to anId.  There is a bug
	in this that does not ever hash to the directory 1, but because of existing datasets
	this must remain, do not want to rehash my databases and it is no big deal"
	self flag: #knownBug.
	^ (anId inject: 0 into: [ : sum : e | sum + e asInteger ]) asReducedSumOfDigits asString! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 3/31/2008 14:18'!
do: aBlock
	"do on a copy in case the do modifies the collection I'm trying to iterate'"
	self findAll copy do: aBlock! !

!SDActiveRecord class methodsFor: 'private' stamp: 'rjl 7/31/2008 17:04'!
ensureDirectories
	| dir |
	dir := self storageDirectory assureExistence.
	0 to: 9 do: [ :num | (dir directoryNamed: num asString) assureExistence ]! !

!SDActiveRecord class methodsFor: 'private' stamp: 'rjl 7/8/2008 09:15'!
ensureReady
	cache := SDConcurrentDictionary on: (Dictionary new: self defaultCacheSize).
	locks := SDConcurrentDictionary on: (WeakKeyDictionary new: self defaultCacheSize)! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 3/31/2008 14:19'!
find: aBlock 
	^ self 
		find: aBlock
		ifAbsent: [ nil ]! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 3/31/2008 14:20'!
find: aBlock ifAbsent: aHandler 
	^ self findAll 
		detect: aBlock
		ifNone: aHandler! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 3/31/2008 14:20'!
find: aBlock ifPresent: aHandler 
	^ self findAll 
		detect: aBlock
		ifFound: aHandler! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 2/4/2008 18:04'!
findAll
	^ self allCaches values! !

!SDActiveRecord class methodsFor: 'queries' stamp: 'rjl 3/31/2008 14:20'!
findAll: aBlock 
	^ self findAll select: aBlock! !

!SDActiveRecord class methodsFor: 'crash recovery' stamp: 'rjl 7/31/2008 16:57'!
finishPartialCommits
	"find where .new exists but .obj doesn't, rename .new to
	.obj to finish commit'"
	
	[ self storageDirectory fileNamesRecursively 
		select: [ :each | each endsWith: '.new' ]
		thenDo: 
			[ :each | 
			| objFile dir |
			objFile := each copyReplaceAll: '.new' with: '.obj'.
			dir := self storageDirFor: each.
			(dir fileExists: objFile) ifFalse: 
				[ dir rename: each toBe: objFile ] ] ] 
		on: Error
		do: [ :err | Transcript show: err ]! !

!SDActiveRecord class methodsFor: 'private' stamp: 'rjl 5/9/2008 09:52'!
loadObjectFrom: anId 
	^ 
	[ SmartRefStream 
		readOnlyFileNamed: ((self storageDirFor: anId) fullNameFor: anId , '.obj')
		do: [ :file | file sandstoneNextAndClose ] ] 
		on: Error
		do: [ :err | SDLoadError signal: err messageText ]! !

!SDActiveRecord class methodsFor: 'private' stamp: 'rjl 7/7/2008 23:13'!
lockFor: anInstance 
	^ locks 
		at: anInstance id
		ifAbsentPut: [ Monitor new ]! !

!SDActiveRecord class methodsFor: 'system startup' stamp: 'rjl 7/31/2008 17:02'!
shutDown
	"keep the image really small, database will be reloaded on startup"
	self allSubclassesDo: [ :e | e coolDown ]! !

!SDActiveRecord class methodsFor: 'system startup' stamp: 'rjl 7/31/2008 17:02'!
startUp
	"clear and then reload entire db into ram on a low priority background thread"
	[ self allSubclassesDo: 
		[ :each | 
		each
			coolDown;
			warmUp ] ] 
		forkAt: Processor systemBackgroundPriority
		named: 'loading SDActiveRecords'! !

!SDActiveRecord class methodsFor: 'private' stamp: 'rjl 4/10/2008 20:08'!
storageDirFor: anId 
	"Grab the correct hashed subdirectory for this record"
	^ self storageDirectory directoryNamed: (self dirNameFor: anId)! !

!SDActiveRecord class methodsFor: 'private' stamp: 'rjl 4/26/2008 22:19'!
storageDirectory
	"compute the path of superclasses all the way up to ActiveRecord, storing 
	subclass records as a subdirectory of the superclasses directory 
	allows ActiveRecord to deal with inheritance"
	| dir parentClass |
	self == SDActiveRecord ifTrue: 
		[ Error signal: 'ActiveRecord itself is not storable, you must only store subclasses' ].
	dir := self defaultBaseDirectory.
	parentClass := self superclass.
	[ parentClass == SDActiveRecord ] whileFalse: 
		[ dir := dir directoryNamed: parentClass name.
		parentClass := parentClass superclass ].
	^ dir directoryNamed: self name! !

!SDActiveRecord class methodsFor: 'actions' stamp: 'rjl 5/9/2008 20:46'!
warmUp
	| loadTime |
	loadTime := 
	[ self
		ensureReady;
		ensureDirectories;
		finishPartialCommits;
		deleteFailedCommits.
	self allCurrentVersionNames do: 
		[ :each | 
		[ self cachedLoadFrom: (each copyUpTo: $.) ] 
			on: Error
			do: [ :err | Transcript show: err ] ] ] timeToRun milliSeconds.
	Transcript
		show: self name , ' loaded in ' , loadTime asString;
		cr! !

!SDActiveRecord methodsFor: 'comparing' stamp: 'rjl 7/31/2008 16:49'!
= anObject 
	"asking the object isMemberOf ensures that if it's a proxy that message 
	will be forwarded to the real object.  Checking this condition in reverse
	anObject class, will fail because anObject class will be the ProxyClass"

	^ (anObject isMemberOf: self class) and: [ id = anObject id ]! !

!SDActiveRecord methodsFor: 'actions' stamp: 'rjl 5/9/2008 20:48'!
abortChanges
	"Rollback object to the last saved version"
	self class cache 
		removeKey: id
		ifAbsent: [ SDError signal: 'Deleted or new objects cannot be aborted' ].
	self becomeForward: (self class cachedLoadFrom: id)! !

!SDActiveRecord methodsFor: 'converting' stamp: 'rjl 4/10/2008 20:20'!
asReferenceMarker
	isNew ifTrue: 
		[ "*********** USE THIS EXCEPTION AS DESIGN REFLECTION INVOCATOR ***********
		Programmers may reach this point several times until they get the intended use of
		this persistency solution. This is expected **by design** to make atomic saves really small 
		and consistent. So commits of active records which have other active records as parts (at any deep)
		are restricted intentionally. They only are allowed when all its sub active records are previously commited.
		To be conscious about what consequences will have to make big objects to be atomically saved refer to:
			http://www.ccs.neu.edu/groups/IEEE/ind-acad/brewer/     and 
			http://www.enterpriseintegrationpatterns.com/ramblings/18_starbucks.html
		
		Only the programmer knows the proper logical commit order for his data!! This is not a relational database,
		if you absolutely need several objects to be atomically saved, then you should make them all part of a 
		single aggregate, all of your objects should not be active records, only your aggregate roots are active records...
			http://domaindrivendesign.org/discussion/messageboardarchive/Aggregates.html"
		SDCommitError signal: 'An object is being saved while referencing an unsaved peer of type ' , self class name , '.  You must save that record first!!' ].
	^ SDRecordMarker new
		id: id ;
		className: self class name ;
		yourself! !

!SDActiveRecord methodsFor: 'actions' stamp: 'rjl 5/13/2008 23:59'!
commit
	"convenience method for a locked save"
	^ self commit: []! !

!SDActiveRecord methodsFor: 'actions' stamp: 'rjl 5/13/2008 23:59'!
commit: aBlock 
	^ (self class lockFor: self) critical: 
		[ aBlock value.
		self save ]! !

!SDActiveRecord methodsFor: 'accessing' stamp: 'rjl 4/26/2008 22:26'!
createdOn
	^ createdOn! !

!SDActiveRecord methodsFor: 'actions' stamp: 'rjl 5/9/2008 20:48'!
critical: aBlock 
	^ (self class lockFor: self) critical: aBlock! !

!SDActiveRecord methodsFor: 'actions' stamp: 'rjl 7/31/2008 16:50'!
delete
	"this method is not thread safe and should only be called within the 
	body of a call to #critical:"
	| dir |
	self flag: #notThreadSafe.
	dir := (self class storageDirFor: id) assureExistence.
	self onBeforeDelete.
	dir deleteFileNamed: id , '.obj'.
	(dir fileNamesMatching: id , '.*') do: [ :e | dir deleteFileNamed: e ].
	self class cache removeKey: id ifAbsent: [  ].
	self onAfterDelete.
	self initialize! !

!SDActiveRecord methodsFor: 'comparing' stamp: 'rjl 3/31/2008 14:08'!
hash
	^ id hash! !

!SDActiveRecord methodsFor: 'accessing' stamp: 'rjl 1/16/2008 18:40'!
id
	^ id! !

!SDActiveRecord methodsFor: 'accessing' stamp: 'rjl 7/11/2008 20:58'!
indexString
	"All instance variable's asStrings as a single delimeted string for easy searching"
	
	^ String streamContents: 
		[ :s | 
		self allInstVarNames do: 
			[ :each | 
			(self instVarNamed: each) ifNotNilDo: 
				[ :value | 
				s
					nextPutAll: value asString;
					nextPutAll: '~~' ] ] ]! !

!SDActiveRecord methodsFor: 'initialize-release' stamp: 'rjl 1/16/2008 18:41'!
initialize
	super initialize.
	id := UUID new asString36.
	createdOn := updatedOn := TimeStamp now.
	version := 0.
	isNew := true! !

!SDActiveRecord methodsFor: 'testing' stamp: 'rjl 5/12/2008 20:43'!
isNew
	"Only answers true before an objects first save."
	^ isNew ifNil: [ isNew := true ]! !

!SDActiveRecord methodsFor: 'testing' stamp: 'rjl 5/12/2008 20:43'!
isSandstoneActiveRecord
	"Answers true if the receiver is a Sandstone Active Record."
	^ true! !

!SDActiveRecord methodsFor: 'events' stamp: 'rjl 4/27/2008 02:16'!
onAfterDelete
	"for overriding in subclasses to hook the objects lifecycle"
	! !

!SDActiveRecord methodsFor: 'events' stamp: 'rjl 4/27/2008 02:29'!
onAfterFirstSave
	"for overriding in subclasses to hook the objects lifecycle"
	! !

!SDActiveRecord methodsFor: 'events' stamp: 'rjl 4/27/2008 02:29'!
onAfterSave
	"for overriding in subclasses to hook the objects lifecycle"
	! !

!SDActiveRecord methodsFor: 'events' stamp: 'rjl 4/27/2008 02:29'!
onBeforeDelete
	"for overriding in subclasses to hook the objects lifecycle"
	! !

!SDActiveRecord methodsFor: 'events' stamp: 'rjl 5/9/2008 09:56'!
onBeforeFirstSave
	"for overriding in subclasses to hook the objects lifecycle"
	createdOn := TimeStamp now! !

!SDActiveRecord methodsFor: 'events' stamp: 'rjl 4/27/2008 02:16'!
onBeforeSave
	"for overriding in subclasses to hook the objects lifecycle"
	updatedOn := TimeStamp now.
	version := version + 1.
	isNew := false! !

!SDActiveRecord methodsFor: 'actions' stamp: 'rjl 5/13/2008 23:59'!
save
	"this method is not thread safe and should only be called within the 
	body of a call to #critical:, use #commit to safely save the object
	in a thread safe manner."
	| isFirstSave |
	self flag: #notThreadSafe.
	self validate.
	(isFirstSave := isNew) ifTrue: [ self onBeforeFirstSave ].
	self onBeforeSave.
	self class cache at: id put: self.
	self sandstoneDeepCopy sandstoneMarkReferences saveToFile.
	isFirstSave ifTrue: [ self onAfterFirstSave ].
	self onAfterSave.
	^ self! !

!SDActiveRecord methodsFor: 'private' stamp: 'rjl 7/31/2008 16:38'!
saveToFile
	"The basic idea here is to make a save as atomic as possible and no data 
	is corrupted, no partial writes, thus renaming files as atomic."
	| currentVersion newVersion oldVersion dir |
	dir := self class storageDirFor: id.
	currentVersion := dir fullNameFor: id , '.obj'.
	newVersion := currentVersion , '.new'.
	oldVersion := currentVersion , '.old'.
	"just in case a previous commit failed and left junk around"
	dir deleteFileNamed: newVersion.
	"the flush ensures all data is actually written to disk before moving on"
	SmartRefStream newFileNamed: newVersion
		do: [ :file | file sandstoneNextPutObjOnly: self ; flush ].
	dir deleteFileNamed: oldVersion.
	"the pre-commit, on first save there won't be a current version, and fileExists is 
	too expensive to check when it'll always be there except on first save"
	[ dir rename: currentVersion toBe: oldVersion ] ifError: ["just ignore it"].
	"now the actual commit"
	dir rename: newVersion 	toBe: currentVersion! !

!SDActiveRecord methodsFor: 'accessing' stamp: 'rjl 3/31/2008 14:17'!
updatedOn
	^ updatedOn! !

!SDActiveRecord methodsFor: 'actions' stamp: 'rjl 3/31/2008 14:17'!
validate
	"for subclasses to override and throw exceptions to prevent saves"! !

!SDActiveRecord methodsFor: 'accessing' stamp: 'rjl 3/31/2008 14:17'!
version
	^ version! !

SDActiveRecord subclass: #SDPersonMock
	instanceVariableNames: 'name dateOfBirth description father mother children buddy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Tests'!

SDPersonMock subclass: #SDManMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Tests'!

!SDPersonMock class methodsFor: 'as yet unclassified' stamp: 'rjl 4/1/2008 11:53'!
testPerson
	^ (self new)
		name: 'mzqfmmv zptnhli';
		dateOfBirth: Date today - 12000 atRandom days;
		description: 'Rxvalpv tdpqkvv ikjcscw bigjmeb vukntxj qxshdtt wkczzio bqpqacu whluhqv.  Lqlwajh!!  Qknwpfd peeskqc oarthtv pfblwjj yndlxks.  .  Ucnlocq iuiiluk txkkzmh dshkhmq uokcwqy oiktkxl awxmpep rkkcmis xcgyoeg jodtjaf ntwijzp?  Bqpjsiq qthzwtx xcnqbag ausurqp xatoqar jytguon?  Bpigdij jgijxep bjgttpr kklsfaw rdoikwz!!  Hzdbjxc?  Ehwflyy qfcqntk mlhcjql ecbtrtk egxldpk rypalvw ndngbdl jhhdxts zrfjtaz gccrnni dwuqxwm nmifzcq sxkgkxh.  Kwtzsjv ghvjqqm lfgibdt rufcowp kavabmi bpveqsr shjzsft xqaxivy fjqydns ryyggif.

Jshooyy jsyojlv miusnaj onpdiss hypkzzd qaunpqd rrvgnws ekiswyv?  Glhxkkk?  Pzyjuot raaefbv cnxmbsd?  Jabaniw uirjkcm jocxnhd!!  Erwblox qikxfez.

Ezswaga cnrzhqi jrdikos kkcncxd eoewflm ylzilve viumpqm uiyqhvv azrezhc jjeesfd rfdgsgg wfmxfye iisisju vhjourb.

Yicqnqd zhaioos npnjjsc hxfwlfr ozynyjs!!  Qavvubu uodeedp?  Fjdgbxu ryswazg ifumqpv jtlifnd?  Blciucl kypalot?  Dstnwqj kwzpxrk bgewcyp triddbr acvrkey pwgcleb sqtxajv svzpnwk unnlmtg oqnbpsq svtnxdo!!

Ywodawk uikhwek kyqivqj iojkwiw.  Bjcsnpu jtfpmqd!!  Crwlngk qeeeuci nnakbai hncfdkk kbhehju ttdsdcf zqulfpj pmvtmfa xrusxuy wbamfee opzjdia hcrfdnz tiasrqz wkwidbg?  Tzlwcst twaeuwm tfhreal igamlby saekozk tjnxohl ogcdhva fckbaii utqvhjg?  Nrynpjl dniycpm kkvytuu bnuxrev zrvbcph.  Awfbhgg xtyffnz lwjkhdo evmvogt vqfqppp chdtxcr ktiwujg vcgqoya thgkhac ncagoxy unuukan gntyowz obmiwmf!!  Okwjujz tfghbxi jupstni xbzpgau zlxeblm!!  Llxuwqc gupeurb ltwyzzj xxanyln qgrtigr?

Vudeenm hnfwxay rtaacau ymmyxbi lpcbamg ifopjuw guhctxx radytrh yubjcjc lnjucta qinzmlf.  Cnunlvp gdhcgrq oxeojsd?  Bbkjtne kzlvdso xtmgqhj pfyroxl brmqhkt gvqnftz aupxtsg.

Krzxaye!!  Clhbjoq ubxtlsc jzhggvl updbzxe.

Vhtetst ruwpukn jdttpba?  Ctwactb ljoeiqa pubapwc cioporv?

Talkecn dbddhuw rxfybrf iwdxfdo spdbdyk vhxbgrm elqngon dytngbm knqxaqv zrltvgh snjkzig rzypaly ekabqcg.  Xxxmegt otxzkhh vxpyjkn pnhgpfx qsnrhjo ziftvuu ivvfacz nhdajef ezksurr gvfepxx.  Lqdldbo wegkzlk qxgqpux hfbtydd hbqfhea gxuksjm hvunuwa?  Lxqkddp bccukhy odljtnp nouapus dcqpkqz lgpxpcs fmaehsc cgybese gujcbqz icjzamy tvmvwlf dvtkpng!!  !!  Okqxkhh dfuulea?  Ratgmpz?  Pfmgfbk qhggllc.  Balobww?

Wqoyfli xlxenvi ngtdshb bhpmyhd.  Kxsidry wijdkem oyuutvw msunbhq vaektbt yfapmwl yjrwmxi xgzfpbk hxcmydy jgaybjh magjtcf.  Koxatqi ivvultq yptadcp ygqutkn dizybis nvsvfhx tdhcqfy ihvqsvs paakztf uzokxhk xlcfhbr wejdutf wywzrqs tnlswyo?  Glawqav nvndvdf cbqzhce iuygwer twyxquv pjklwnv tbnazjw vuvxvgi?

Rpyaiqq rnvfyzk fgbsbjc zhftunh uvmxaov vgvwzwq fpuurxc!!  Zemojud eadzsas wzfdcuv vxvulbc ahtiijq yclzbvf rspxhrc lymmwja!!  Mfmgrrb!!  Cyfuuvp iabqntx volbiij ebjihqw ypxvukv wnghvwo fhqwyuh tlmeyrl oxcmotx uemizkc xvbgzqh xsdqtcj xfbzrgg?  Jmtauxu!!  Kbigzux slwjszd manystg usxbiya kfgdygh wrclmih chqtyew orkrazt pekdcrh oexrivu bnbrerh?

Xbkcyvl xivutzr iitbwnm eouuiux iwaansa oxzygwa sosqxvi jkinurb bedwzss?  Uspwzru.  Eogmjki raowczb!!  ?  Lfzhatu ldnvhfn rzfqfcl yzhbxpo evahsye eibcwlx ygknqms terepdi acvezip lyqydat bksesji.  Sncraae sropzde xdhuuuf?  ?

Vtcevnw dqwwzqe kqmakan wboltvp axuhsio eddpqvk hmaqsst kbqyeqg qjnlkph zjrrcdr glyqfak!!  Ciofqeq qzfzdxn aumczcs yxzdrqu hxnlhmo ihnowav nqggjoi dfdxzqr.

Wiedtvt jpikavx hkxvzqi eyobbcb hxhktut qpgasux bnwnzhp xaceikr comlnmg jkdzrhn hctccgm zcjgqbc llklclt!!

Bgyypck fvgaauj bzetcjo rqixcnx ggwuzax cnknyiv vbtnkxj zkmenql ynxyqpp vqnvihq qydzixk jvsbxhw qnbphdl uddayfe!!  Glalnun gbtcspy kxnzokz ecdpgpr kcmvcdf ngczhkp oovhcik yvlzbgl?';
		yourself! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 3/10/2008 21:44'!
buddy
	^ buddy! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 3/10/2008 21:44'!
buddy: anObject
	buddy := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/11/2007 10:33'!
children
	^ children! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/11/2007 10:33'!
children: anObject
	children := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
dateOfBirth
	^ dateOfBirth! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
dateOfBirth: anObject
	dateOfBirth := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:08'!
description
	^ description! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
description: anObject
	description := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
father
	^ father! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
father: anObject
	father := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
mother
	^ mother! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
mother: anObject
	mother := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
name
	^ name! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 12/7/2007 17:07'!
name: anObject
	name := anObject! !

!SDPersonMock methodsFor: 'accessing' stamp: 'rjl 4/22/2008 10:45'!
refreshed
	^ self class atId: id! !

SDPersonMock subclass: #SDWomanMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb-Tests'!

Object subclass: #SDConcurrentDictionary
	instanceVariableNames: 'lock dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb'!

!SDConcurrentDictionary commentStamp: 'rjl 5/9/2008 20:58' prior: 0!
A SDConcurrentDictionary is just a dictionary wrapper so I can wrap a critical around mutating methods I need in ActiveRecord!

!SDConcurrentDictionary class methodsFor: 'instance creation' stamp: 'rjl 5/9/2008 20:11'!
on: aDictionary 
	^ self new
		dictionary: aDictionary;
		yourself! !

!SDConcurrentDictionary methodsFor: 'copying' stamp: 'rjl 5/9/2008 21:40'!
, aCollection 
	^ lock critical: [ self class on: dictionary , aCollection ]! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 20:30'!
at: aKey
	^ dictionary at: aKey! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 21:11'!
at: aKey ifAbsent: aBlock 
	^ lock critical: 
		[ dictionary 
			at: aKey
			ifAbsent: aBlock ]! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 20:53'!
at: aKey ifAbsentPut: aBlock 
	^ lock critical: 
		[ dictionary 
			at: aKey
			ifAbsentPut: aBlock ]! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 20:53'!
at: aKey put: aValue 
	^ lock critical: 
		[ dictionary 
			at: aKey
			put: aValue ]! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 20:11'!
dictionary: anObject
	dictionary := anObject! !

!SDConcurrentDictionary methodsFor: 'testing' stamp: 'rjl 5/9/2008 20:29'!
includesKey: aKey
	^ dictionary includesKey: aKey! !

!SDConcurrentDictionary methodsFor: 'initialization' stamp: 'rjl 5/9/2008 21:35'!
initialize
	super initialize.
	"I'm using a Monitor rather than a Semaphor here because I need to support 
	reentrant operations by the same process, a Semaphor is too low level"
	lock := Monitor new! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 20:38'!
keysAndValuesDo: aBlock
	^ dictionary keysAndValuesDo: aBlock! !

!SDConcurrentDictionary methodsFor: 'removing' stamp: 'rjl 5/9/2008 20:51'!
removeKey: aKey ifAbsent: aBlock 
	^ lock critical: 
		[ dictionary 
			removeKey: aKey
			ifAbsent: aBlock ]! !

!SDConcurrentDictionary methodsFor: 'accessing' stamp: 'rjl 5/9/2008 20:39'!
values
	^ dictionary values! !

Object subclass: #SDRecordMarker
	instanceVariableNames: 'id className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb'!

!SDRecordMarker commentStamp: 'rjl 4/10/2008 21:32' prior: 0!
I exist to mark a reference to another object in the serialized file, I'm replaced by a real object when I'm deserialized.  I'm basically a manually invoked proxy being used because getting a real proxy that inherits from ProtoObject to serialize seemed hurculean.!

!SDRecordMarker methodsFor: 'converting' stamp: 'rjl 5/6/2008 18:19'!
asOriginalObject
	"this needs to call cachedLoadFrom not findById in order to allow cycles in the serialized graph
	this allows an object that references an unloaded object during the loadAll to force it's load instead of failing"
	| origClass |
	origClass := Smalltalk at: className.
	"I'm checking inheritsFrom: here so that any classes that used to be activeRecords but aren't anymore
	that had serialized instances are caught and return nil when resolved rather than blow up.  This happens
	often during development when you're changing your model a lot"
	^ (origClass inheritsFrom: SDActiveRecord) 
		ifTrue: [ (Smalltalk at: className) cachedLoadFrom: id ]
		ifFalse: [ nil ]! !

!SDRecordMarker methodsFor: 'accessing' stamp: 'rjl 12/11/2007 09:17'!
className
	^ className! !

!SDRecordMarker methodsFor: 'accessing' stamp: 'rjl 12/11/2007 09:17'!
className: anObject
	className := anObject! !

!SDRecordMarker methodsFor: 'testing' stamp: 'rjl 7/31/2008 17:09'!
deservesSandstoneReferenceMark
	^ false! !

!SDRecordMarker methodsFor: 'accessing' stamp: 'rjl 12/11/2007 09:17'!
id
	^ id! !

!SDRecordMarker methodsFor: 'accessing' stamp: 'rjl 12/11/2007 09:17'!
id: anObject
	id := anObject! !

!SDRecordMarker methodsFor: 'testing' stamp: 'rjl 7/8/2008 15:41'!
isSandstoneMarker
	^ true! !

!UndefinedObject methodsFor: '*sandstonedb-testing' stamp: 'rjl 7/31/2008 17:09'!
deservesSandstoneReferenceMark
	^ false! !

!UndefinedObject methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:37'!
sandstoneDeepCopy
	^ self! !

!UndefinedObject methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:37'!
sandstoneDeepCopyVisits: visitedParts
	^ self! !

!Dictionary methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 20:34'!
sandstoneDeepCopyVisits: visitedParts 
	"sandstoneDeepCopy works just like deepCopy until it hits another active record
	at which point the copying stops, and the actual references is returned."
	| newObject |
	visitedParts at: self ifPresent: [ :it | ^ it ].
	newObject := self copy.
	newObject do: 
		[ :each | 
		each isSandstoneActiveRecord ifFalse: 
			[ self 
				at: (self keyAtValue: each)
				put: (each sandstoneDeepCopyVisits: visitedParts) ] ].
	^ newObject! !

!Dictionary methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 20:35'!
sandstoneMarkReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone active records to become references.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	self deservesSandstoneReferenceMark ifFalse: [ ^ self ].
	visitedParts at: self ifPresent: [:it | ^ self ].
	visitedParts at: self put: self.
	self do: 
		[ :each | 
		each isSandstoneActiveRecord 
			ifTrue: [ self at: (self keyAtValue: each) put: each asReferenceMarker  ]
			ifFalse: [ each sandstoneMarkReferencesVisits: visitedParts ] ].
	^ self! !

!Dictionary methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 20:35'!
sandstoneResolveReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone references to active record to become active records.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	visitedParts at: self ifPresent: [ :it | ^ self ].
	visitedParts at: self put: self.
	"It is crucial to modify the introspectee by iterating a copy of it"
	self copy do: 
		[ :each | 
		each isSandstoneMarker 
			ifTrue: [ self at: (self keyAtValue: each) put: each asOriginalObject ]
			ifFalse: [ each sandstoneResolveReferencesVisits: visitedParts ] ].
	^ self! !

!LookupKey methodsFor: '*sandstonedb' stamp: 'rjl 7/31/2008 17:09'!
deservesSandstoneReferenceMark
	^ true! !

Error subclass: #SDError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb'!

!SDError commentStamp: 'rjl 4/10/2008 21:36' prior: 0!
I'm just an abstract error!

SDError subclass: #SDCommitError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb'!

!SDCommitError commentStamp: 'rjl 4/10/2008 21:33' prior: 0!
Clearly, I'm thrown on a commit failure, duh!!'!

SDError subclass: #SDLoadError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SandstoneDb'!

!SDLoadError commentStamp: 'rjl 4/10/2008 20:24' prior: 0!
I'm thrown when an object fails to load from disk, either because the file was corrupt or because it was deleted.!

!Integer methodsFor: '*sandstonedb' stamp: 'rjl 4/10/2008 10:08'!
asReducedSumOfDigits
	"Answers the sum of the digits present in the 
	decimal representation of the receiver 
	but also repeating the procedure if the 
	answers is greater than 9."
	^ 10 <= self 
		ifFalse: [ self ]
		ifTrue: 
			[ self = 10 
				ifTrue: [ 0 ]
				ifFalse: 
					[ (self asString 
						inject: 0
						into: [ :sum :e | sum + e digitValue ]) asReducedSumOfDigits ] ]! !

!Set methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 19:53'!
sandstoneDeepCopyVisits: visitedParts 
	"sandstoneDeepCopy works just like deepCopy until it hits another active record
	at which point the copying stops, and the actual references is returned."
	| newObject |
	visitedParts at: self ifPresent: [ :it | ^ it ].
	newObject := self copy.
	newObject do: 
		[ :each | 
		each isSandstoneActiveRecord ifFalse: 
			[ newObject remove: each.
			newObject add: (each sandstoneDeepCopyVisits: visitedParts) ] ].
	^ newObject! !

!Set methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 19:54'!
sandstoneMarkReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone active records to become references.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	self deservesSandstoneReferenceMark ifFalse: [ ^ self ].
	visitedParts at: self ifPresent: [:it | ^ self ].
	visitedParts at: self put: self.
	self doWithIndex: 
		[ :each :index | 
		each isSandstoneActiveRecord 
			ifTrue: [ self remove: each; add: each asReferenceMarker ]
			ifFalse: [ each sandstoneMarkReferencesVisits: visitedParts ] ].
	^ self! !

!Set methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 19:55'!
sandstoneResolveReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone references to active record to become active records.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	visitedParts at: self ifPresent: [ :it | ^ self ].
	visitedParts at: self put: self.
	"It is crucial to modify the introspectee by iterating a copy of it"
	self copy doWithIndex: 
		[ :each :index | 
		each isSandstoneMarker 
			ifTrue: [ self remove: each; add: each asOriginalObject ]
			ifFalse: [ each sandstoneResolveReferencesVisits: visitedParts ] ].
	^ self! !

!SmallInteger methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:35'!
sandstoneDeepCopy
	^ self! !

!SmallInteger methodsFor: '*sandstonedb-serialization' stamp: 'rjl 5/12/2008 22:35'!
sandstoneDeepCopyVisits: visitedParts
	^ self! !

!Magnitude methodsFor: '*sandstonedb' stamp: 'rjl 7/31/2008 17:09'!
deservesSandstoneReferenceMark
	^ false! !

!Collection methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 18:56'!
sandstoneDeepCopyVisits: visitedParts 
	"sandstoneDeepCopy works just like deepCopy until it hits another active record
	at which point the copying stops, and the actual references is returned."
	| newObject |
	visitedParts at: self ifPresent: [ :it | ^ it ].
	newObject := self copy.
	newObject doWithIndex: 
		[ :each :index  | 
		each isSandstoneActiveRecord ifFalse: 
			[ newObject at: index put: (each sandstoneDeepCopyVisits: visitedParts) ] ].
	^ newObject! !

!Collection methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 18:58'!
sandstoneMarkReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone active records to become references.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	self deservesSandstoneReferenceMark ifFalse: [ ^ self ].
	visitedParts at: self ifPresent: [:it | ^ self ].
	visitedParts at: self put: self.
	self doWithIndex: 
		[ :each :index | 
		each isSandstoneActiveRecord 
			ifTrue: [ self at: index put: each asReferenceMarker ]
			ifFalse: [ each sandstoneMarkReferencesVisits: visitedParts ] ].
	^ self! !

!Collection methodsFor: '*sandstonedb' stamp: 'rjl 7/8/2008 18:59'!
sandstoneResolveReferencesVisits: visitedParts 
	"Make components of the introspectee which are 
	Sandstone references to active record to become active records.
	Do this deeply (sub components)."
	self class isMeta ifTrue: [ ^ self ].
	visitedParts at: self ifPresent: [ :it | ^ self ].
	visitedParts at: self put: self.
	"It is crucial to modify the introspectee by iterating a copy of it"
	self copy doWithIndex: 
		[ :each :index | 
		each isSandstoneMarker 
			ifTrue: [ self at: index put: each asOriginalObject ]
			ifFalse: [ each sandstoneResolveReferencesVisits: visitedParts ] ].
	^ self! !

!Array methodsFor: '*sandstonedb' stamp: 'rjl 7/31/2008 17:09'!
deservesSandstoneReferenceMark
	^ {  Array. DependentsArray. WeakArray  } includes: self class! !

!InstructionStream methodsFor: '*sandstonedb' stamp: 'rjl 7/31/2008 17:09'!
deservesSandstoneReferenceMark
	^ false! !

!SmartRefStream methodsFor: '*sandstonedb' stamp: 'rjl 4/10/2008 21:39'!
sandstoneNextAndClose
	"Speedy way to grab one object. Only use when we are inside an object
	binary file.I created my own version of nextAndClose to get rid of the 
	interactive stuff the real one tries to do.  If I fail, then I fail, so be it"
	| obj |
	byteStream peek = ReferenceStream versionCode 
		ifFalse: [ SDLoadError signal: 'old object file' ].
	obj := self next.
	self close.
	^ obj! !

!SmartRefStream methodsFor: '*sandstonedb' stamp: 'rjl 3/31/2008 21:34'!
sandstoneNextPutObjOnly: anObject 
	"Really write three objects: (version, class structure, object).  But only when called from the outside.  Not in fileOut format.  No class definitions will be written for instance-specific classes.  Error if find one.  (Use nextPut: instead)"
	| info |
	topCall 
		ifNil: 
			[ topCall := anObject.
			super nextPut: ReferenceStream versionCode.
			info := self instVarInfo: anObject.
			self uniClasesDo: [ :cls | cls error: 'Class defn not written out.  Proceed?' ].
			objCount := 0.
			super nextPut: info.
			super nextPut: anObject.	"<- the real writing"
			"Class inst vars not written here!!"
			topCall := nil
			"references is an IDict of every object that got written
			(in case you want to take statistics)"
			"Transcript cr; show: structures keys printString."	"debug"	"reset it" ]
		ifNotNil: [ super nextPut: anObject ]! !

!FileDirectory methodsFor: '*sandstonedb' stamp: 'rjl 4/16/2008 12:17'!
fileNamesRecursively
	"Answer a collection containing the file names of all the files 
	in the subtree of the file system whose root is this directory."
	| result todo dir |
	result := OrderedCollection new: 100.
	todo := OrderedCollection with: self.
	[ todo notEmpty ] whileTrue: 
		[ dir := todo removeFirst.
		result addAll: dir fileNames.
		todo addAll: (dir directoryNames collect: [ :n | dir directoryNamed: n ]) ].
	^ result asArray! !

!Morph methodsFor: '*sandstonedb' stamp: 'rjl 7/31/2008 17:09'!
deservesSandstoneReferenceMark
	^ false! !
SDActiveRecord initialize!
